
#include <os.h>
#include <libndls.h>
#include "math.h"
#include "graph.h"
#include "asciiprinting.h"


  
														
 

static unsigned int coche_width = 18;
static unsigned int coche_height = 12;
static unsigned char coche[12][18] = {
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
};


 
int rand() {
  static int m_w = 56789;
  static int m_z = 38765;

  m_z = 36969 * (m_z & 65535) + (m_z >> 16);
  m_w = 18000 * (m_w & 65535) + (m_w >> 16);
  return (m_z << 16) + m_w;
}



int dirlist(char* path, char* pattern, char** result)	//stocke dans result une liste des noms des rpertoires prsents sur la calculatrice
{ unsigned char StructDstat[512];
  if(chdir(path)==-1) printf("Erreur de changement de rpertoire\n");
	/*if(chdir("/ndless/")==-1)*/ 
  if (NU_Get_First((struct dstat*)StructDstat, pattern)) {
    printf("Error: dirlist() failed to find file\n");
    NU_Done((struct dstat*)StructDstat);
    return -1;
  }
  int i = 0;
  do {
    char* dirname = (char*) malloc(128);
    strcpy(dirname, (char*) &StructDstat[13]);
    printf("File=%s\n",dirname);//affiche tous les rpertoires, les repertoires . et .. sont inclus
    result[i] = dirname;
    i++;
  } while (NU_Get_Next((struct dstat*)StructDstat) == 0); 
  NU_Done((struct dstat*)StructDstat);
  return i;
}
void DrawRepList(char **repnames, int y, int numfiles)
{
	int i=0;
	for(i=0;i<7;i++)
	{
		if(y+i<numfiles) 
		{
			DrawStr(30,50+i*15,"                                  ",0b0111);
			DrawStr(30,50+i*15,repnames[y+i],0b0111);
		}
	}
}
int ChooseRep(char **repnames)
{
	//char path[1024];
	//strcpy(path,"/documents/");
	//char* repnames[1024];
	int y=0,i;
	char is_key_down=0, is_key_up=0;
	int numfiles = dirlist("/documents/", "*.*", repnames);
	//printf("\nNb repertory=%d, %s",numfiles,repnames[2]);
	clearScreen();
	DrawStr(20,5,"Hexadecimal Editor by CAVIAR V1.0",0b1001);
	DrawStr(5,35,"Choose repertory :",BLACK);
	DrawRepList(repnames, 0, numfiles);
	i=0; y=0;
	DrawStr(20,50+i*15,">",BLACK);
	while (!isKeyPressed(KEY_NSPIRE_ESC)) {
		if(isKeyPressed(KEY_NSPIRE_DOWN) && is_key_down==0)
		{
			is_key_down=1;
			if((y+i)<numfiles-1 && i<7-1) {DrawStr(20,50+i*15," ",BLACK); i++; DrawStr(20,50+i*15,">",BLACK); continue;}
			if(i==6 && (y+i)<numfiles-1) { y++; DrawRepList(repnames, y, numfiles); continue;}
		}
		else if(!isKeyPressed(KEY_NSPIRE_DOWN)) is_key_down=0;
		
		if(isKeyPressed(KEY_NSPIRE_UP) && is_key_up==0)
		{
			is_key_up=1;
			if(i>0) {DrawStr(20,50+i*15," ",BLACK); i--; DrawStr(20,50+i*15,">",BLACK); continue;}
			if(i==0 && y>0) { y--; DrawRepList(repnames, y, numfiles); continue;}
		}
		else if(!isKeyPressed(KEY_NSPIRE_UP)) is_key_up=0;
		if(isKeyPressed(KEY_NSPIRE_ENTER)) {/*printf("\nselected rep =%d",y+i);*/ return y+i;}
		if(isKeyPressed(KEY_NSPIRE_ESC)) return -1;
	} 
}
int ChooseFile(char **filenames, char *repertory)
{
	int y=0,i;
	char is_key_down=0, is_key_up=0, is_key_enter=1;
	int numfiles;
	char path_name[128];
	strcpy(path_name,"/documents/");
	strcat(path_name,repertory);
	strcat(path_name, "/");
	numfiles = dirlist(path_name, "*.*", filenames);
	//printf("\nNb repertory=%d, %s",numfiles,filenames[2]);
	clearScreen();
	DrawStr(20,5,"Hexadecimal Editor by CAVIAR V1.0",0b1001);
	DrawStr(5,35,"Choose file :",BLACK);
	DrawRepList(filenames, 0, numfiles);
	i=0; y=0;
	DrawStr(20,50+i*15,">",BLACK);
	while (!isKeyPressed(KEY_NSPIRE_ESC)) {
		if(isKeyPressed(KEY_NSPIRE_DOWN) && is_key_down==0)
		{
			is_key_down=1;
			if((y+i)<numfiles-1 && i<7-1) {DrawStr(20,50+i*15," ",BLACK); i++; DrawStr(20,50+i*15,">",BLACK); continue;}
			if(i==6 && (y+i)<numfiles-1) { y++; DrawRepList(filenames, y, numfiles); continue;}
		}
		else if(!isKeyPressed(KEY_NSPIRE_DOWN)) is_key_down=0;
		
		if(isKeyPressed(KEY_NSPIRE_UP) && is_key_up==0)
		{
			is_key_up=1;
			if(i>0) {DrawStr(20,50+i*15," ",BLACK); i--; DrawStr(20,50+i*15,">",BLACK); continue;}
			if(i==0 && y>0) { y--; DrawRepList(filenames, y, numfiles); continue;}
		}
		else if(!isKeyPressed(KEY_NSPIRE_UP)) is_key_up=0;
		if(isKeyPressed(KEY_NSPIRE_ENTER) && is_key_enter==0) return y+i;
		else if(!isKeyPressed(KEY_NSPIRE_ENTER)) is_key_enter=0;
		if(isKeyPressed(KEY_NSPIRE_ESC)) return -1;
	} 
}
char *get_filename(char **repnames, char **filenames, char *filename)
{
	int selected_rep,selected_file=-1;
	while(selected_file==-1)
	{
choose_repertory:		
		clrscr();
		do
		{
			selected_rep=ChooseRep(repnames);
			//printf("\nIci, repnames[selected_rep]=%s",repnames[selected_rep]);
		}	while(strcmp(repnames[selected_rep],".")==0 || strcmp(repnames[selected_rep],"..")==0);
		do
		{
			selected_file=ChooseFile(filenames, repnames[selected_rep]);
			if(strcmp(filenames[selected_file],"..")==0) goto choose_repertory;
		} while(strcmp(filenames[selected_file],".")==0);
	}
	strcpy(filename,"/documents/");
	strcat(filename,repnames[selected_rep]);
	strcat(filename,"/");
	strcat(filename,filenames[selected_file]);
	return filename;
}

void DrawCur(int x, int y)
{
	DrawSprite(x, y, coche_height, coche_width, coche, 0);		//gmode=0 : white is translucent    gmode=2 : REPLACE
}
void EraseCur(int x, int y)
{
	EraseSprite(x,y, coche_height, coche_width, coche, WHITE);
}
void disp_bottom_menu(void)
{
	DrawStr(5,190,"1-Open another file",BLACK);
	DrawStr(5,205,"2-Set Byte (decimal value)",BLACK);
	DrawStr(5,220,"3-Exit",BLACK);
}

int getkey(void)
{
	int key=0;
	
	if(isKeyPressed(KEY_NSPIRE_SHIFT)) key=1000;
	
	if(isKeyPressed(KEY_NSPIRE_LEFT)) return key+21;
	if(isKeyPressed(KEY_NSPIRE_UP)) return key+23;
	if(isKeyPressed(KEY_NSPIRE_RIGHT)) return key+22;
	if(isKeyPressed(KEY_NSPIRE_DOWN)) return key+24;
	
	if(isKeyPressed(KEY_NSPIRE_1)) return key+'1';
	if(isKeyPressed(KEY_NSPIRE_2)) return key+'2';
	if(isKeyPressed(KEY_NSPIRE_3)) return key+'3';
	if(isKeyPressed(KEY_NSPIRE_4)) return key+'4';
	if(isKeyPressed(KEY_NSPIRE_5)) return key+'5';
	if(isKeyPressed(KEY_NSPIRE_6)) return key+'6';
	if(isKeyPressed(KEY_NSPIRE_7)) return key+'7';
	if(isKeyPressed(KEY_NSPIRE_8)) return key+'8';
	if(isKeyPressed(KEY_NSPIRE_9)) return key+'9';
	if(isKeyPressed(KEY_NSPIRE_0)) return key+'0';
		
	if(isKeyPressed(KEY_NSPIRE_SHIFT)) key=-32;
	if(isKeyPressed(KEY_NSPIRE_A)) return key+'a';
	if(isKeyPressed(KEY_NSPIRE_B)) return key+'b';
	if(isKeyPressed(KEY_NSPIRE_C)) return key+'c';
	if(isKeyPressed(KEY_NSPIRE_D)) return key+'d';
	if(isKeyPressed(KEY_NSPIRE_E)) return key+'e';
	if(isKeyPressed(KEY_NSPIRE_F)) return key+'f';
	if(isKeyPressed(KEY_NSPIRE_G)) return key+'g';
	if(isKeyPressed(KEY_NSPIRE_H)) return key+'h';
	if(isKeyPressed(KEY_NSPIRE_I)) return key+'i';
	if(isKeyPressed(KEY_NSPIRE_J)) return key+'j';
	if(isKeyPressed(KEY_NSPIRE_K)) return key+'k';
	if(isKeyPressed(KEY_NSPIRE_L)) return key+'l';
	if(isKeyPressed(KEY_NSPIRE_M)) return key+'m';
	if(isKeyPressed(KEY_NSPIRE_N)) return key+'n';
	if(isKeyPressed(KEY_NSPIRE_O)) return key+'o';
	if(isKeyPressed(KEY_NSPIRE_P)) return key+'p';
	if(isKeyPressed(KEY_NSPIRE_Q)) return key+'q';
	if(isKeyPressed(KEY_NSPIRE_R)) return key+'r';
	if(isKeyPressed(KEY_NSPIRE_S)) return key+'s';
	if(isKeyPressed(KEY_NSPIRE_T)) return key+'t';
	if(isKeyPressed(KEY_NSPIRE_U)) return key+'u';
	if(isKeyPressed(KEY_NSPIRE_V)) return key+'v';
	if(isKeyPressed(KEY_NSPIRE_W)) return key+'w';
	if(isKeyPressed(KEY_NSPIRE_X)) return key+'x';
	if(isKeyPressed(KEY_NSPIRE_Y)) return key+'y';
	if(isKeyPressed(KEY_NSPIRE_Z)) return key+'z';
	if(isKeyPressed(KEY_NSPIRE_DEL)) return 300;	//Can be set with another value
	
	return 0;	
}

char *gets(char *buf, int nbchar, char color)
{
	int key=0,is_key_pressed=0,i=0,x_pos0;
	for(i=0;i<nbchar;i++) buf[i]=0;
	i=0; x_pos0=x_pos;
	while(getkey()!=0) ;
	while(!isKeyPressed(KEY_NSPIRE_ENTER) && i<nbchar)
	{
	  key=getkey();
	  if(isKeyPressed(KEY_NSPIRE_ESC)) return 0;
	  if(is_key_pressed && key) continue ;
	  is_key_pressed=key;
	  if((key>='0' && key<='9') || (key>='a' && key<='z') || (key>='A' && key<='Z'))
	  {
	  	Printf1("%c",(char)key,color);
	  	buf[i]=key; i++;
	  }
	}
	return buf;
}
void print_ascii_array(int xx,int yy, int i, FILE *pFile)
{
	int x,y,c;
	fseek(pFile,yy*10,0);
	for(y=0;y<10;y++)
	{
		for(x=0;x<10;x++)
		{
			c=fgetc (pFile);
			MoveTo(215+x*9,y*15);
			if((x+(yy+y)*10)==(xx+(yy+i)*10)) Printf1("%c",c,BLACK);
			else Printf1("%c",c,0b0111);
			if(feof(pFile)) return ;
		}
	}
}
void printframe(int xx, int yy, int i, FILE *pFile)
{
	int x,y,c;
//	rewind(pFile);
	clrscr();
	disp_bottom_menu();
	MoveTo(0,0);
	fseek(pFile,yy*10,0);
	for(y=0;y<10;y++)
	{
		for(x=0;x<10;x++)
		{
			MoveTo(x*20,y*15);
			Printf1("%02X ",c=fgetc (pFile),BLACK);
			//MoveTo(215+x*9,y*15);
			//if((x+(yy+y)*10)==(xx+(yy+i)*10)) Printf1("%c",c,BLACK);
			//else Printf1("%c",c,0b0111);
			if(feof(pFile)) return ;
		}
	}
	print_ascii_array(xx,yy, i, pFile);
}
void disp_current_value(int x, int y, int i, FILE *pFile)
{
	int c;
	fseek(pFile,x+(y+i)*10,0);
	MoveTo(5,155);
	c=fgetc(pFile);
	Printf1("Value:0x%02X ",c,BLACK);
	Printf1("0d%ld  ",c,BLACK);
	MoveTo(200,155);
	Printf1("ASCII CODE:%c",c,BLACK);
	Printf1("     ",0,BLACK);
	MoveTo(5,170);
	Printf1("Address &%d     ",x+(y+i)*10,0b0111);
}

int main(void) {

	char *repnames[1024],*filenames[1024],filename[128];	//limit arbitrairement  1024 noms de rpertoires
	int i,ix=0,selected_rep,selected_file=-1,y=0,x=0;
	char is_down_pressed=0,is_up_pressed=0,is_left_pressed=0,is_right_pressed=0,buffer[1024];
	FILE * pFile;
	for(i=0;i<1024;i++) {repnames[i]=0; filenames[i]=0;}
	
	get_filename(repnames, filenames, filename);

  pFile = fopen (filename,"rb+");
  if (pFile==NULL) {printf("No such file"); goto end;}
	
	
	i=0;

	printframe(x,y,i,pFile);
	DrawCur(x*20, y*15);
	while (!isKeyPressed(KEY_NSPIRE_ESC) && !isKeyPressed(KEY_NSPIRE_3))
	{
		if(isKeyPressed(KEY_NSPIRE_1))
		{	
			if(pFile) fclose (pFile);	//Close current file
 			for(i=0;i<1024;i++)
  		{
  			if(repnames[i]) free(repnames[i]);
  			if(filenames[i]) free(filenames[i]);
  		}
			for(i=0;i<1024;i++) {repnames[i]=0; filenames[i]=0;}		//can be retired
			get_filename(repnames, filenames, filename);
			pFile = fopen (filename,"rb+");
		  if (pFile==NULL) {printf("Pas de fichier"); goto end;}
		  i=0;
			printframe(x,y,i,pFile);
			x=0; y=0; DrawCur(x*20, y*15);
		}
		if(isKeyPressed(KEY_NSPIRE_2))
		{
			MoveTo(0,225);
			Printf1("Enter Decimal value : 0d",0,BLACK);
			fseek(pFile,x+(y+i)*10,0);
			if(gets(buffer,10,BLACK)) fputc(atoi(buffer),pFile);
			printf("\nvaleur entre : %d",atoi(buffer));
			printframe(x,y,i,pFile);
			DrawCur(x*20, y*15);
		}
		
		if(isKeyPressed(KEY_NSPIRE_DOWN) && is_down_pressed==0)
		{
			is_down_pressed=1;
			if(i==10-1)
			{
				EraseCur(x*20, i*15); 
				y++; 
				printframe(x,y,i,pFile);
				disp_current_value(x, y, i, pFile);
				DrawCur(x*20, i*15);
			}
			else
			{
				EraseCur(x*20, i*15); 
				i++; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
			//	printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			 
		}
		else
		{
		
		if(!isKeyPressed(KEY_NSPIRE_DOWN)) is_down_pressed=0;
		}
		
		if(isKeyPressed(KEY_NSPIRE_UP) && is_up_pressed==0)
		{
			is_up_pressed=1;
			if(i==0)
			{
				EraseCur(x*20, i*15); 
				if(y>0) y--; 
				printframe(x,y,i,pFile);
				disp_current_value(x, y, i, pFile);
				DrawCur(x*20, i*15);
			}
			else
			{
				EraseCur(x*20, i*15); 
				i--; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
				//printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			 
		}
		else
		{
			if(!isKeyPressed(KEY_NSPIRE_UP)) is_up_pressed=0;
		}
		
		if(isKeyPressed(KEY_NSPIRE_LEFT) && is_left_pressed==0)
		{
			is_left_pressed=1;
			if(x==0)
			{
				EraseCur(x*20, i*15); 
				x=9; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
			//	printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			else
			{
				EraseCur(x*20, i*15); 
				x--; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
				//printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			 
		}
		else
		{
			if(!isKeyPressed(KEY_NSPIRE_LEFT)) is_left_pressed=0;
		}
		
		if(isKeyPressed(KEY_NSPIRE_RIGHT) && is_right_pressed==0)
		{
			is_right_pressed=1;
			if(x==9)
			{
				EraseCur(x*20, i*15); 
				x=0; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
				//printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			else
			{
				EraseCur(x*20, i*15); 
				x++; 
				print_ascii_array(x,y, i, pFile);
				disp_current_value(x, y, i, pFile);
				//printframe(y, pFile); 
				DrawCur(x*20, i*15);
			}
			 
		}
		else
		{
			if(!isKeyPressed(KEY_NSPIRE_RIGHT)) is_right_pressed=0;
		}
	}
  
end: 
	if(pFile) fclose (pFile);
  for(i=0;i<1024;i++) 
  {
  	if(repnames[i]) free(repnames[i]);
  	if(filenames[i]) free(filenames[i]);
  }
  return 0;
}

